package bloat_test

import (
	"fmt"
	"testing"

	"git.bivouac.wiki/go/bloat"
)

func TestItem(t *testing.T) {
	type typ struct {
		A int    `xml:"A"`
		B string `xml:"B"`
	}
	data := typ{
		A: 1,
		B: "hello",
	}
	trySender, err := bloat.NewEncBloat[typ]()
	if err != nil {
		t.Log(err.Error())
		t.Errorf("error on newbloat")
	}
	tryReceiver, err := bloat.NewEncBloat[typ]()
	if err != nil {
		t.Log(err.Error())
		t.Errorf("error on newbloat")
	}
	cyphertext, err := trySender.WriteEnc(data, tryReceiver)
	if err != nil {
		t.Log(err.Error())
		t.Errorf("error on write")
	}
	// t.Log(string(cyphertext))
	plainobj, err := tryReceiver.ReadEnc(cyphertext, trySender)
	if err != nil {
		t.Errorf("error on read")
		t.Errorf(err.Error())
	}
	if plainobj.A != 1 {
		fmt.Println(err)
		t.Errorf("int not equal")
	}
	if plainobj.B != "hello" {
		fmt.Println(err)
		t.Errorf("string not hello")
	}

}
